import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-angular-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "igniteui-angular-core";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-angular-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { Dictionary$2 } from "igniteui-angular-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { TransitionOutSpeedType } from "./TransitionOutSpeedType";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
/**
 * @hidden
 */
export declare class FinancialEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    get position(): number;
    set position(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _dataSource;
    get dataSource(): FinancialCalculationDataSource;
    set dataSource(a: FinancialCalculationDataSource);
    private _supportingCalculations;
    get supportingCalculations(): FinancialCalculationSupportingCalculations;
    set supportingCalculations(a: FinancialCalculationSupportingCalculations);
    private _basedOn;
    get basedOn(): IList$1<string>;
    set basedOn(a: IList$1<string>);
}
/**
 * @hidden
 */
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    static $t: Type;
    protected hu(): List$1<SeriesLayerPropertyOverlay>;
    private aaj;
    private aah;
    private aai;
    private aag;
    private aak;
    kz(): any;
    q7(a: SeriesView): void;
    xx: FinancialSeriesView;
    protected get_e8(): boolean;
    ai(): Axis[];
    ku(a: any, b: string): any;
    mi(a: string): string;
    protected zg(): number;
    private ze;
    aj(a: Point): Point[][];
    al(a: Point): Point[][];
    constructor();
    aa6: Brush;
    v6(): Brush;
    v7(): Brush;
    o8(): void;
    protected get_em(): boolean;
    protected get_f6(): boolean;
    xg: CategoryAxisBase;
    xz: NumericYAxis;
    z6: string;
    get yc(): IFastItemColumn$1<number>;
    set yc(a: IFastItemColumn$1<number>);
    private x7;
    zx: string;
    get ya(): IFastItemColumn$1<number>;
    set ya(a: IFastItemColumn$1<number>);
    private x5;
    z2: string;
    get yb(): IFastItemColumn$1<number>;
    set yb(a: IFastItemColumn$1<number>);
    private x6;
    zk: string;
    get x9(): IFastItemColumn$1<number>;
    set x9(a: IFastItemColumn$1<number>);
    private x4;
    aaa: string;
    get ye(): IFastItemColumn$1<number>;
    set ye(a: IFastItemColumn$1<number>);
    private x8;
    zt: string;
    zp: string;
    zr: string;
    zn: string;
    zv: string;
    protected gc(): boolean;
    ym: boolean;
    protected yh: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    yo(): boolean;
    protected aan(a: AssigningCategoryStyleEventArgs): void;
    protected xp: CategorySeriesRenderManager;
    protected aal(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean, g: number): void;
    y6(a: Point): number;
    ke(a: Point, b: boolean): number;
    kc(a: Point, b: boolean): number;
    ir(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    wm(a: Point, b: boolean, c: boolean): Point;
    i8(a: Point, b: boolean, c: boolean): number;
    i4(a: Point, b: boolean, c: boolean): number;
    i6(a: Point, b: boolean, c: boolean): number;
    y8(a: Point, b: boolean, c: boolean): number;
    y9(a: Point, b: boolean, c: boolean): number;
    za(a: Point, b: boolean, c: boolean): number;
    wi(a: Point, b: boolean, c: boolean): Point;
    wk(a: Point, b: boolean, c: boolean): Point;
    aa8(a: Point, b: boolean, c: boolean): Point;
    aa7(a: Point, b: boolean, c: boolean): Point;
    aa9(a: Point, b: boolean, c: boolean): Point;
    qh(): void;
    protected sz(a: Rect, b: Rect): void;
    protected sy(a: Rect, b: Rect): void;
    protected yr: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected ys: Dictionary$2<string, string>;
    private yd;
    private aaf;
    private yg;
    protected rg(a: any, b: string, c: any, d: any): void;
    yj(a: any): boolean;
    yi(a: any): boolean;
    protected w9(a: number, b: number, c: Axis): any[];
    protected zd(a: SeriesView): number;
    protected zf(a: SeriesView): number;
    w8(a: number, b: number): any[];
    private x3;
    protected get_ff(): boolean;
    o9(): void;
    dh(a: any, b: Point, c: boolean): HighlightingInfo;
    zh(a: Point): number;
    protected x2(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected x1(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected yk(): boolean;
    it(a: Point): number;
    j7(a: Point): number;
    protected get_ft(): boolean;
    a0(): CategoryAxisBase;
    j9(a: Point): number;
    kr(a: Point): any;
    xk: CategoryFrame;
    xm: CategoryFrame;
    xi: CategoryFrame;
    xj(): CategoryFrame;
    protected y7(a: Rect, b: Rect, c: Rect): number;
    xr: CategoryTransitionInMode;
    yn: boolean;
    protected go(): boolean;
    protected xq(): CategoryTransitionInMode;
    protected c5(): TransitionInSpeedType;
    protected c8(): TransitionOutSpeedType;
    aao(a: CategoryFrame, b: FinancialSeriesView): void;
    aam(a: CategoryFrame, b: FinancialSeriesView): void;
    hf(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    xs: CategoryTransitionSourceFramePreparer;
    zb(a: FinancialSeriesView): number;
    protected pc(): void;
    rz(a: boolean): void;
    protected gp(): boolean;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected yp(a: IList$1<string>): boolean;
    get yq(): boolean;
    protected yl(): boolean;
    protected aae(a: FinancialEventArgs): void;
    protected get yy(): IEnumerable$1<number>;
    private _yv;
    private yv;
    protected get yx(): IEnumerable$1<number>;
    private _yu;
    private yu;
    protected get yw(): IEnumerable$1<number>;
    private _yt;
    private yt;
    y0(a: IList$1<number>): IList$1<number>;
    private yf;
    protected yz(): IList$1<string>;
    private y4;
    getOpenColumnAsArray(): number[];
    private y2;
    getHighColumnAsArray(): number[];
    private y3;
    getLowColumnAsArray(): number[];
    private y1;
    getCloseColumnAsArray(): number[];
    private y5;
    getVolumeColumnAsArray(): number[];
    protected ph(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected xt(a: number, b: number): FinancialCalculationDataSource;
    zc(a: number): number;
    protected xu(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    get categoryAxis(): CategoryAxisBase;
    private xl;
    r0(a: Rect, b: RenderSurface): void;
    r1(): void;
    private xh;
    rx(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    aw(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private xn;
    get xo(): CategoryMode;
    set xo(a: CategoryMode);
    protected get_fn(): boolean;
    sb(a: Brush, b: Brush): void;
    private aap;
    private xy;
    private x0;
    kt(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialCalculationSupportingCalculations extends Base {
    static $t: Type;
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
}
/**
 * @hidden
 */
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    static $t: Type;
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class FinancialCalculationDataSource extends Base {
    static $t: Type;
    private _openColumn;
    get openColumn(): IList$1<number>;
    set openColumn(a: IList$1<number>);
    private _closeColumn;
    get closeColumn(): IList$1<number>;
    set closeColumn(a: IList$1<number>);
    private _highColumn;
    get highColumn(): IList$1<number>;
    set highColumn(a: IList$1<number>);
    private _lowColumn;
    get lowColumn(): IList$1<number>;
    set lowColumn(a: IList$1<number>);
    private _volumeColumn;
    get volumeColumn(): IList$1<number>;
    set volumeColumn(a: IList$1<number>);
    private _indicatorColumn;
    get indicatorColumn(): IList$1<number>;
    set indicatorColumn(a: IList$1<number>);
    private _typicalColumn;
    get typicalColumn(): CalculatedColumn;
    set typicalColumn(a: CalculatedColumn);
    private _trueRange;
    get trueRange(): CalculatedColumn;
    set trueRange(a: CalculatedColumn);
    private _trueLow;
    get trueLow(): CalculatedColumn;
    set trueLow(a: CalculatedColumn);
    private _period;
    get period(): number;
    set period(a: number);
    private _shortPeriod;
    get shortPeriod(): number;
    set shortPeriod(a: number);
    private _longPeriod;
    get longPeriod(): number;
    set longPeriod(a: number);
    private _count;
    get count(): number;
    set count(a: number);
    private _calculateFrom;
    get calculateFrom(): number;
    set calculateFrom(a: number);
    private _calculateCount;
    get calculateCount(): number;
    set calculateCount(a: number);
    private _multiplier;
    get multiplier(): number;
    set multiplier(a: number);
    private _minimumValue;
    get minimumValue(): number;
    set minimumValue(a: number);
    private _maximumValue;
    get maximumValue(): number;
    set maximumValue(a: number);
    private _specifiesRange;
    get specifiesRange(): boolean;
    set specifiesRange(a: boolean);
    private _series;
    get series(): FinancialSeries;
    set series(a: FinancialSeries);
}
/**
 * @hidden
 */
export declare abstract class FinancialSeriesView extends SeriesView {
    static $t: Type;
    cf: FinancialSeries;
    cd: FinancialBucketCalculator;
    ch: number;
    cg(a: CategoryFrame): boolean;
    ci(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract ce(): FinancialBucketCalculator;
    a4(): void;
    getDefaultTooltipTemplate(): string;
    protected an(): void;
}
